<?php

// plFotogalerie.1.4                             //
// fn-fotos, Funktionen makethumb und fotos      //
// von Peter Lehmann, Version 1.4 vom 03.11.2017 //
//        http://www.peter-lehmann.com           //
///////////////////////////////////////////////////

// makethumb:
// Thumbnails in $tndir automatisch aus den *.jpg oder *.JPG Bildern in $imgdir, generieren.
// Die Thumbnails werden quadratisch zurechtgeschnitten mit Breite $width, oder im Orginalseitenverhltnis
// mit der Lnge $width. 
// $stretch=0, Bilder quadratisch
// $stretch=1, Bilder quadratisch Ausschnitt etwas gezogen
// $stretch=2, Bilder im Orginalseitenverhltnis
//
// makethumb (string $tndir, string $imgdir, int $width, int $stretch)
// mit den Defaultwerten ./tn, ./images, 125px, 1

function makethumb ($tndir = "./tn", $imgdir = "./images", $width = 125, $stretch = 1)
{
	$workdir = getcwd();

	chdir ($imgdir);

	$dir = glob("{*.jpg,*.JPG}",GLOB_BRACE);
	chdir ( $workdir );

	foreach ($dir as $file) {
	    $img = $imgdir.'/'.$file;
	    $tmb = $tndir.'/'.$file;

	    if (file_exists($tmb) == false) {
		if (is_dir($tndir) == false) { mkdir($tndir); echo "Directory $tndir erstellt<br/>"; }

		echo "Datei $tmb, \n";
		$imgsrc = imagecreatefromjpeg( $img );

		$breite = imagesx( $imgsrc );
		$hoehe = imagesy( $imgsrc );
		  
		$factor = 1;
		$offset = 0;
		$dstX = $dstY = $srcX = $srcY =0;
		$dstW = $dstH = $width;
		$srcW = $breite; $srcH = $hoehe;

		echo "Breite $breite, Hhe $hoehe, \n";


		if ($breite >= $hoehe) {
		    switch ( $stretch )
		    {
		      case 0:
			$srcX = ($breite-$hoehe)/2;
			$srcW = $hoehe;
		      break;
		      case 1:
			$factor = sqrt( abs( $breite/$hoehe));
			$breitekor = intval( $hoehe*$factor );
			$srcX = ($breite-$breitekor)/2;
			$srcW = $breitekor;
		      break;
		      case 2:
			$dstH = intval( $hoehe/$breite*$width );
		      break;
		      default:
			echo "stretch = $stretch ist ungltig <br/>\n";
		      break;
		    }
		}

		else {
		    switch ( $stretch )
		    {
		      case 0:
			$srcY = ($hoehe-$breite)/2;
			$srcH = $breite;
		      break;
		      case 1:
			$factor = sqrt( abs( $hoehe/$breite));
			$hoehekor = intval( $breite*$factor );
			$srcY = ($hoehe-$hoehekor)/2;
			$srcH = $hoehekor;
		      break;
		      case 2:
			$dstW = intval( $breite/$hoehe*$width );
		      break;
		      default:
			echo "stretch = $stretch ist ungltig <br/>\n";
		      break;
		    }
		}

		$tmbdst = imagecreatetruecolor( $dstW, $dstH );
		imagecopyresampled( $tmbdst, $imgsrc, $dstX, $dstY, $srcX, $srcY, $dstW, $dstH, $srcW, $srcH);
		imagejpeg( $tmbdst, $tmb, 80);

		echo "srcOfffset X=$srcX, Y=$srcY, Dest $dstW x $dstH, Src $srcW x $srcH, \n";
		echo "Factor= " . number_format( $factor, 2 ) . "<br/>\n";

	    }

	    else {  }

	}
	return;
}


// fotos:
// HTML-Tabelle der Fotogallerie generieren. 
// $perRow:	Anzahl Bilder per Reihe
// $tndir:	Thumbnaildirectory
// $imgdir:	Imagedirectory
// $titel=0:	pro Bild keinen Titeltext ausgeben
// $titel=1:	pro Bild einen Titeltext ausgeben
// Format:	Text pro Bild ist je eine Zeile im File tndir/titel.txt
// 
// fotos (int, $perRow, string $tndir, string $imgdir, int $titel)
// mit den Defaultwerten 4, ./tn, ./images, 0

function fotos ($perRow = 4, $tndir = "./tn", $imgdir = "./images", $titel = 0)
{
	$workdir = getcwd();
	$imgNum = 0;

	echo "<!-- **** plFotogalerie.1.4 Peter Lehmann peter-lehmann.com**** -->\n";
	echo "<table class=\"foto\" >\n";
	chdir ($tndir);

	if ($titel == 1) {$datei = fopen("titel.txt","r");}

	foreach (glob("{*.jpg,*.JPG}",GLOB_BRACE) as $file) {
		    //$a modulo $b ist 0, erstes Bild der Reihe
		if ($imgNum%$perRow == 0) { echo "<tr>\n"; }
		
		if ($titel == 1) { $text = rtrim(fgets($datei,1000)); }

		$imgNum++;

		echo "<td><a href=\"$imgdir/$file\" rel=\"lightbox-$tndir\"";
		if ($titel == 1) { echo " title=\"$text\""; }
		echo "><img src=\"$tndir/$file\" alt=\"\"/></a>";

		if ($titel == 1) { echo "<p>$text</p>"; }
		echo "</td>\n";

		if ($imgNum%$perRow == 0) { echo "</tr>\n"; }
	}
		if ($imgNum%$perRow != 0) { echo "</tr>\n"; }
	echo "</table>\n";
	echo "<p class=\"plcopyright\"> plFotogalerie.1.4 &copy; 2017 <a href=\"http://www.peter-lehmann.com\">Peter Lehmann</a> </p>\n";

	if ($titel == 1) { fclose($datei); }

	chdir ($workdir);
	return;
}
?>